// 001 u_firedac_connection_using_interfaces.pas
// 06 dec 2015

// -- (C) Felix John COLIBRI 2015
// -- documentation: http://www.felix-colibri.com

unit u_firedac_connection_using_interfaces;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Memo1: TMemo;
    create_connection_: TButton;
    create_connection_detail_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_connection_Click(Sender: TObject);
    procedure create_connection_detail_Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  implementation
    uses
        uAdPhysIntf
      , uAdStanDef
      , uADPhysIB
      ;

    {$R *.dfm}

  procedure display(p_text: string);
    begin
      Form1.Memo1.Lines.Add(p_text);
    end; // display


    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end;

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.create_connection_Click(Sender: TObject);
      var l_i_fd_physical_connection: IADPhysConnection;
      begin
        ADPhysManager.ConnectionDefs.Storage.FileName := '$(ADHOME)\DB\ADConnectionDefs.ini';
        ADPhysManager.Open;
        // -- create the physical connection using one of the ConnectionDef
        ADPhysManager.CreateConnection('DbDemos', l_i_fd_physical_connection);

        l_i_fd_physical_connection.Open;
        display('Connected to DbDemo');

        l_i_fd_physical_connection.Close;
        l_i_fd_physical_connection := nil;
      end; // create_connection_Click

    procedure TForm1.create_connection_detail_Click(Sender: TObject);
      var l_i_fd_physical_connection: IADPhysConnection;
      begin
        ADPhysManager.ConnectionDefs.Storage.FileName := '$(ADHOME)\DB\ADConnectionDefs.ini';
        ADPhysManager.Open;

        // -- buid an in-memory connection def
        with ADPhysManager.ConnectionDefs.AddConnectionDef do
        begin
          Name := 'my_connection_def';

          // -- chamge some members
          DriverID:= 'FB25';
          Server:= 'localhost';
          Database:= 'C:\programs\us\db\firedac\_data_fb_25\fb_25_EMPLOYEE.FDB';
          UserName:= 'SYSDBA';
          PassWord:= 'masterkey';

          Params.Add('Tracing=True');
          AsBoolean['ReadOnly']:= True;
        end;

        // Connect through my definition
        ADPhysManager.CreateConnection('my_connection_def', l_i_fd_physical_connection);

        l_i_fd_physical_connection.Open;
        display('Connected to MyDefNew (EMPLOYEE.FDB)');

        l_i_fd_physical_connection.Close;
        l_i_fd_physical_connection := nil;
      end; // create_connection_detail_Click

end.
